mescc: Support gcc-3.2: Add getpid, signal.
[mes.git] / build-aux / check-mescc.sh
1 #! /bin/sh
2
3 # Mes --- Maxwell Equations of Software
4 # Copyright © 2017,2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
5 #
6 # This file is part of Mes.
7 #
8 # Mes is free software; you can redistribute it and/or modify it
9 # under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 3 of the License, or (at
11 # your option) any later version.
12 #
13 # Mes is distributed in the hope that it will be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with Mes.  If not, see <http://www.gnu.org/licenses/>.
20
21 if [ -n "$BUILD_DEBUG" ]; then
22     set -x
23 fi
24
25 export BLOOD_ELF GUILE HEX2 M1 MES MESCC
26 export M1FLAGS HEX2FLAGS PREPROCESS
27 export MES_ARENA MES_PREFIX MES_SEED
28 export BUILD_DEBUG
29 export LIBC CC32LIBS MESCCLIBS
30
31 MES=${MES-src/mes}
32 MESCC=${MESCC-scripts/mescc}
33 GUILE=${GUILE-guile}
34 MES_PREFIX=${MES_PREFIX-.}
35
36 HEX2=${HEX2-hex2}
37 M1=${M1-M1}
38 BLOOD_ELF=${BLOOD_ELF-blood-elf}
39 MES_SEED=${MES_SEED-../mes-seed}
40 MESCC=${MESCC-$(command -v mescc)}
41 [ -z "$MESCC" ] && MESCC=scripts/mescc
42 MES=${MES-$(command -v mes)}
43 [ -z "$MES" ] && MES=src/mes
44
45 if ! command -v $GUILE > /dev/null; then
46     GUILE=true
47 fi
48
49 tests="
50 t
51 00-exit-0
52 01-return-0
53 02-return-1
54 03-call
55 04-call-0
56 05-call-1
57 06-call-!1
58 10-if-0
59 11-if-1
60 12-if-==
61 13-if-!=
62 14-if-goto
63 15-if-!f
64 16-if-t
65 20-while
66 21-char[]
67 22-while-char[]
68 23-pointer
69 30-strlen
70 31-eputs
71 32-compare
72 33-and-or
73 34-pre-post
74 35-compare-char
75 36-compare-arithmetic
76 37-compare-assign
77 38-compare-call
78 40-if-else
79 41-?
80 42-goto-label
81 43-for-do-while
82 44-switch
83 45-void-call
84 46-function-static
85 47-function-expression
86 48-function-destruct
87 49-global-static
88 4a-char-array
89 50-assert
90 51-strcmp
91 52-itoa
92 53-strcpy
93 54-argv
94 60-math
95 61-array
96 62-array
97 63-struct-cell
98 64-make-cell
99 65-read
100 70-printf
101 71-struct-array
102 72-typedef-struct-def
103 73-union
104 74-multi-line-string
105 75-struct-union
106 76-pointer-arithmetic
107 77-pointer-assign
108 78-union-struct
109 79-int-array
110 7a-struct-char-array
111 7b-struct-int-array
112 7c-dynarray
113 7d-cast-char
114 7e-struct-array-access
115 7f-struct-pointer-arithmetic
116 7g-struct-byte-word-field
117 7h-struct-assign
118 7i-struct-struct
119 7j-strtoull
120 7k-for-each-elem
121 7l-struct-any-size-array
122 7m-struct-char-array-assign
123 7n-struct-struct-array
124 7o-struct-pre-post
125 7p-struct-cast
126 7q-bit-field
127 7r-sign-extend
128 7s-struct-short
129 80-setjmp
130 81-qsort
131 82-define
132 83-heterogenoous-init
133 84-struct-field-list
134 85-sizeof
135 86-strncpy
136 87-sscanf
137 90-strpbrk
138 91-fseek
139 92-stat
140 93-fread-fwrite
141 94-unsetenv
142 95-signal
143 "
144
145 # 90: needs GNU, fails for mescc, passes for tcc
146 broken="$broken
147 7s-struct-short
148 "
149
150 # gcc not supported
151 CC=
152 set +e
153 expect=$(echo $broken | wc -w)
154 pass=0
155 fail=0
156 total=0
157 for t in $tests; do
158     if [ -z "${t/[012][0-9]-*/}" ]; then
159         LIBC=c-mini
160         MESCCLIBS="-l c-mini"
161     elif [ -z "${t/[78][0-9a-z]-*/}" ]; then
162         LIBC=c+tcc
163         MESCCLIBS="-l c+tcc"
164     elif [ -z "${t/9[0-9]-*/}" ]; then
165         LIBC=c+gnu
166         MESCCLIBS="-l c+gnu"
167     else
168         LIBC=c
169         MESCCLIBS=
170     fi
171     sh build-aux/test.sh "scaffold/tests/$t" &> scaffold/tests/"$t".log
172     r=$?
173     total=$((total+1))
174     if [ $r = 0 ]; then
175         echo $t: [OK]
176         pass=$((pass+1))
177     else
178         echo $t: [FAIL]
179         fail=$((fail+1))
180     fi
181 done
182
183 tests="
184 00_assignment
185 01_comment
186 02_printf
187 03_struct
188 04_for
189 05_array
190 06_case
191 07_function
192 08_while
193 09_do_while
194
195 10_pointer
196 11_precedence
197 12_hashdefine
198 13_integer_literals
199 14_if
200 15_recursion
201 16_nesting
202 17_enum
203 18_include
204 19_pointer_arithmetic
205
206 20_pointer_comparison
207 21_char_array
208 22_floating_point
209 23_type_coercion
210 24_math_library
211 25_quicksort
212 26_character_constants
213 27_sizeof
214 28_strings
215 29_array_address
216
217 30_hanoi
218 31_args
219 32_led
220 33_ternary_op
221 34_array_assignment
222 35_sizeof
223 36_array_initialisers
224 37_sprintf
225 38_multiple_array_index
226 39_typedef
227
228 40_stdio
229 41_hashif
230 42_function_pointer
231 43_void_param
232 44_scoped_declarations
233 45_empty_for
234 47_switch_return
235 48_nested_break
236 49_bracket_evaluation
237
238 50_logical_second_arg
239 51_static
240 52_unnamed_enum
241 54_goto
242 55_lshift_type
243 "
244
245 broken="$broken
246 18_include
247
248 22_floating_point
249 23_type_coercion
250 24_math_library
251 26_character_constants
252 27_sizeof
253 28_strings
254
255 34_array_assignment
256 39_typedef
257
258 40_stdio
259 42_function_pointer
260 49_bracket_evaluation
261 55_lshift_type
262 "
263
264 #22_floating_point       ; float
265 #23_type_coercion        ; float
266 #24_math_library         ; float
267 #27_sizeof               ; float
268 #28_strings              ; TODO: strncpy strchr strrchr memset memcpy memcmp
269 #30_hanoi                ; fails with GCC
270 #34_array_assignment     ; fails with GCC
271 #39_typedef              ;unsupported: (decl (decl-spec-list (stor-spec (typedef)) (type-spec (typename "MyFunStruct"))) (init-declr-list (init-declr (ptr-declr (pointer) (ident "MoreFunThanEver")))))
272
273 #40_stdio                ; f* functions
274 #42_function_pointer     ; f* functions
275 #49_bracket_evaluation   ; float
276
277 LIBC=c+gnu
278 MESCCLIBS="-l c+gnu"
279
280 expect=$(echo $broken | wc -w)
281 ARGS="arg1 arg2 arg3 arg4 arg5"
282 export ARGS
283 for t in $tests; do
284     if [ ! -f scaffold/tinycc/"$t.c" ]; then
285         echo ' [SKIP]'
286         continue;
287     fi
288     sh build-aux/test.sh "scaffold/tinycc/$t" &> scaffold/tinycc/"$t".log
289     r=$?
290     total=$((total+1))
291     if [ $r = 0 ]; then
292         echo $t: [OK]
293         pass=$((pass+1))
294     else
295         echo $t: [FAIL]
296         fail=$((fail+1))
297     fi
298 done
299 [ $expect != 0 ] && echo "expect: $expect"
300 [ $fail != 0 ] && echo "failed: $fail"
301 [ $fail -lt $expect ] && echo "solved: $(($expect - $fail))"
302 echo "passed: $pass"
303 echo "total:  $total"
304 if [ $fail != 0 -a $fail -gt $expect ]; then
305     echo FAILED: $fail/$total
306     exit 1
307 elif [ $fail != 0 ]; then
308     echo PASS: $pass/$total
309 else
310     echo PASS: $total
311 fi